* Program:		RIMain.PRG
* Description:	Main program file for Referential Integrity Builder
*               Intended to be called from BUILDER.APP, so all environment
*               and other settings should have been made there.
* Version:		.050
* -----------------------------------------------------------------------------------------

#DEFINE C_BADCALL1_LOC	"The RI Builder cannot be run as a standalone application. Use BUILDER.APP instead."
#DEFINE C_BADCALL2_LOC	"The proper context for the RI Builder has not been established."
#DEFINE C_VCX			"ribuildr.vcx"
*** DH: added another VCX definition
#DEFINE C_VCX2			"sfribuildr.vcx"
*** DH: changed main program name to RIMAIN.
*#DEFINE C_MAIN			"CMDMAIN"
#DEFINE C_MAIN			"RIMAIN"

*** DH: corrected a bug in the parameter list
*PARAMETERS p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p12, p13, p14, p15
PARAMETERS p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16

PRIVATE m.wbReturnValue, m.cParmstring
LOCAL wbi
IF PROGRAM(0) == C_MAIN
	*- called directly, so fail
*** DH: made it auto-register ourselves if we're called directly.
*	=MESSAGEBOX(C_BADCALL1_LOC)
	lnSelect = select()
	select 0
	use home() + 'wizards\builder' again
	locate for NAME = 'Stonefield Referential Integrity Builder'
	if not found()
		locate for NAME = 'Referential Integrity Builder'
		scatter memvar memo
		replace TYPE with 'XRI'
		insert into BUILDER from memvar
		replace NAME with 'Stonefield Referential Integrity Builder', ;
			PROGRAM with sys(16), ;
			CLASSLIB with 'sfribuildr.vcx', ;
			CLASSNAME with 'sfribuildr'
	endif not found()
	wait window 'SFRIBuildr now registered as the RI Builder'
	use
	select (lnSelect)
*** DH: end of new code
	RETURN
ENDIF

IF TYPE("wboObject") # 'O'
	*- environment doesn't appear to be set up properly
	=MESSAGEBOX(C_BADCALL2_LOC)
	RETURN
ENDIF

RELEASE wboName
PUBLIC wboName

m.cParmstring = ""
FOR m.wbi = 1 to PARAMETERS()
	m.thisp = "p" + LTRIM(STR(m.wbi))
	m.cParmstring = m.cParmstring + IIF(!EMPTY(cParmString),",","") + m.thisp	&& will create ...,p1,p2,..." etc
ENDFOR

SELECT (wboObject.wbaEnvir[5])

m.wbReturnValue = wboObject.wbReturnValue

*** DH: included our VCX in the list
*SET CLASSLIB TO C_VCX ADDITIVE
SET CLASSLIB TO C_VCX, C_VCX2 ADDITIVE
	
wboName = CREATEOBJ(wboObject.wbcBldrClass, &cParmstring)		&& all builders and wizards are modal formsets

IF TYPE("_TIMING") <> "U" AND _TIMING
	RETURN
ENDIF

IF TYPE("wboName") = "O"
	wboName.SHOW
#IF 0
	IF wboName.wbcName = "RIBUILDR"
		SET SKIP OF BAR _MWI_DEBUG OF _MSM_TOOLS .f.
		SET SKIP OF BAR _MWI_TRACE OF _MSM_TOOLS .f.
	ENDIF
#ENDIF
ENDIF

wboObject.wbReturnValue = m.wbReturnValue

IF wboObject.wblModal							&& don't release, if modeless for testing
	RELEASE wboName
	IF FILE(C_VCX)
		RELEASE CLASSLIB C_VCX
	ENDIF
ENDIF

