* Mofifications:	2/5/99  -	Disabled function AddTimeStamp, which defaults
* 								that we need a timestamp column for tables with certain datatypes.  
* 								2/5/99  -	Make all constraint names unique in order to meet
*													SS rule of all database objects names	being unique.
*									2/5/99  - Add NONCLUSTERED clause TO adding of Pkey
* 								2/11/99 - Added "v" prefix to view name
*									3/02/99 - Changed method ExtractFieldNames() to a simple string 
*														conversion. Renamed original one to ExtractFieldNames_Original()
*									DON'T FORGET TABLE SORT ORDER CHANGE!
#INCLUDE ALLDEFS.H
#DEFINE MAX_PARAMS 254
#DEFINE MAX_ROWS 180
#DEFINE WIZARD_CLOSING	.T.

*************************************************
DEFINE CLASS UpsizeEngine2 AS UpsizeEngine
*************************************************


	FUNCTION AddTimeStamp
		PARAMETERS lcTableName
		LOCAL lcEnumFieldsTbl, aCount[1]

		* ## 2/5/99 We don't want a default timestamp column, otherwise 
		* we have to uncheck it for each table.
		* We'll just disable this logic until we need it.
		RETURN .F.

		*This routine returns True if a table has float, real, binary, 
		*varbinary, image, or text data types in them

		lcEnumFieldsTbl = this.EnumFieldsTbl
		
		SELECT COUNT(*) FROM (lcEnumFieldsTbl) ;
			WHERE Tblname = lcTableName ;
			AND (DataType = "M" or ;
				 DataType = "G" or ;
				 DataType = "P") ;
			INTO ARRAY aCount

		RETURN aCount[1] > 0
	ENDFUNC


	PROCEDURE BuildIndexSQL
		LOCAL lcEnum_Indexes, lcSQL, lcRmtTable, lcRmtIdxName, lcRmtType, ;
			lcConstraint, lcTSClause, lcNonClustered

		*Build the CREATE INDEX sql string
		lcEnum_Indexes = this.EnumIndexesTbl
		SELECT (lcEnum_Indexes)
			
		SCAN FOR Exported=.F.
			*Get remote table name
			lcRmtTable = LEFT(this.RemotizeName(RTRIM(&lcEnum_Indexes..IndexName)),30)
			lcRmtType = TRIM(&lcEnum_Indexes..RmtType)
			lcRmtExpr = TRIM(&lcEnum_Indexes..RmtExpr)
			lcRmtName = TRIM(&lcEnum_Indexes..RmtName)
			IF this.ServerType = ORACLE_SERVER
				lcRmtName = this.UniqueOraName(lcRmtName)
			ENDIF

			*check index type; deal with Oracle and Primary differently
			IF lcRmtType = "PRIMARY KEY" OR ;
				(lcRmtType = "UNIQUE" AND this.ServerType = "Oracle") ;
				OR (lcRmtType = "UNIQUE" AND this.ServerType == "SQL Server95") THEN

				* Oracle and SQL95 Unique and Primary Key indexes implemented via ALTER TABLE
				IF this.ServerType = ORACLE_SERVER
					lcTSClause = IIF(!empty(this.TSIndexTSName), " USING INDEX TABLESPACE " + this.TSIndexTSName, "")
					lcSQL = "ALTER TABLE " + lcRmtTable + " ADD (CONSTRAINT " + lcRmtName + ;
							" " + lcRmtType + " (" + lcRmtExpr + ")" + lcTSClause + ")"
				ELSE
					* ## Use this convention for unique db objects...
					* PRIMARY KEY: "PK_" + SubStr(lcRmtName,3)
					* CANDIDATE KEYS: "UQ_" + SubStr(lcRmtName,3)
					
					* ## Add NONCLUSTERED clause when creating a PRIMARY KEY b/c SS
					* defaults to CLUSTERED INDEX.
					IF lcRmtType = "UNIQUE"
						lcRmtname = "UQ_" + SubStr(lcRmtTable,3)
						lcNonClustered = ""
					ELSE
						lcRmtname = "PK_" + SubStr(lcRmtTable,3)
						lcNonClustered = " NONCLUSTERED " && NEED SPACES!
					ENDIF	
*!* Old code ***************************************************************************
*!*						lcSQL = "ALTER TABLE " + lcRmtTable + " ADD CONSTRAINT " + lcRmtName + ;
*!*								" " + lcRmtType + " (" + lcRmtExpr + ")"
*!* Old code ***************************************************************************
					lcSQL = "ALTER TABLE " + lcRmtTable + " ADD CONSTRAINT " + lcRmtName + ;
						" " + lcRmtType + lcNonClustered + " (" + lcRmtExpr + ")"
				ENDIF
			ELSE
				* All other index types (including regular Oracle indexes) are handled here
				lcSQL = "CREATE " + lcRmtType + " INDEX " + lcRmtName + " ON " + lcRmtTable + " (" + lcRmtExpr + ")"
				IF this.ServerType = ORACLE_SERVER
					lcTSClause = IIF(!empty(this.TSIndexTSName), " TABLESPACE " + this.TSIndexTSName, "")
					lcSQL = lcSQL + lcTSClause
				ENDIF
			ENDIF
			
			REPLACE &lcEnum_Indexes..IndexSQL WITH lcSQL, &lcEnum_Indexes..RmtName WITH lcRmtName
		ENDSCAN
	ENDPROC
	
	PROCEDURE GetDefaultMapping
		PARAMETERS aPassedArray
		LOCAL lnOldArea, lcServerConstraint
		
		lnOldArea=SELECT()
		IF NOT USED("TypeMap")
			SELECT 0
			USE TypeMap EXCLUSIVE
		ELSE
			SELECT TypeMap
		ENDIF
		
		*Didn't foresee a problem, thus this cheezy snippet
		IF this.ServerType=="SQL Server95" THEN
			lcServerConstraint="SQL Server"
		ELSE
			IF this.ServerType=="SQL Server" THEN
				lcServerConstraint="SQL Server4x"
			ELSE
				lcServerConstraint=RTRIM(this.ServerType)
			ENDIF
		ENDIF

		SELECT LocalType, RemoteType, VarLength, FullLocal FROM TypeMap ;
			WHERE  TypeMap.Default=.T. AND TypeMap.Server=lcServerConstraint ;
			INTO ARRAY aPassedArray
			
		SELECT(lnOldArea)

	ENDFUNC 
	
		PROCEDURE CreateRmtViews
		PARAMETERS aTableNames
	
		*
		*Creates remote views for tables passed in or all tables that were upsized
		*

		LOCAL lcEnumTablesTbl, lcNewTblName, lnOldArea, lcSQL, lcEnumIndexesTbl, ;
			aPkey, lcEnumFieldsTbl, lcViewErr, llShowTherm, lnTableCount, i, ;
			lcCRLF
		lnOldArea=SELECT()
		lcEnumTablesTbl=this.EnumTablesTbl
		lcEnumIndexesTbl=this.EnumIndexesTbl
		lcEnumFieldsTbl=this.EnumFieldsTbl
		lcCRLF=CHR(10)+CHR(13)

		IF EMPTY(aTableNames)
			DIMENSION aTableNames[1]
			SELECT TblName, RmtTblName FROM (lcEnumTablesTbl) WHERE Exported=.T. ;
			INTO ARRAY aTableNames
			
			IF EMPTY(aTableNames)
				RETURN	&& no tables were actually upsized
			ENDIF
			
			lnTableCount=ALEN(aTableNames,1)
			llShowTherm=.T.
		ENDIF

		IF llShowTherm THEN
			*Only display thermometer if this method is called by ProcessOutput;
			*otherwise the thermometer will be showing the progress
			*for the RemotizeView method already
			this.InitTherm(RMTZING_TABLE_LOC,lnTableCount,0)
			lnTableCount=0
		ENDIF
		
		IF this.ViewConnection=="" THEN
			IF this.UserConnection=="" OR this.CreateNewDB THEN
				this.CreateConnDef
			ELSE
				this.ViewConnection=this.UserConnection
			ENDIF
		ENDIF
		
		SELECT (lcEnumTablesTbl)

		FOR i=1 TO ALEN(aTableNames,1)
			IF llShowTherm THEN
				lcMessage=STRTRAN(THIS_TABLE_LOC,"|1",RTRIM(aTableNames[i,1]))
				this.UpdateTherm(lnTableCount,lcMessage)
				lnTableCount=lnTableCount+1
			ENDIF
			
			lcViewErr=""
			
			*rename the original table
			lcNewTblName=this.UniqueTorVName(aTableNames[i,1])
			RENAME TABLE (RTRIM(aTableNames[i,1])) TO (lcNewTblName)
			
			lcSQL="SELECT * FROM " + aTableNames[i,2]
			*create the view
			* ## Add "v" prefix to view name to differentiate from underlying tablename in code
			CREATE SQL VIEW ("v" + RTRIM(aTableNames[i,1])) REMOTE CONNECT RTRIM(this.ViewConnection) ;
				AS &lcSQL

			*See if table has primary key or candidate
			DIMENSION aPkey[1]
			aPkey=.F.
			SELECT RmtExpr FROM (lcEnumIndexesTbl) WHERE RTRIM(IndexName)==RTRIM(aTableNames[i,1]) ;
				AND LclIdxType="Primary key" INTO ARRAY aPkey
				
			*If not but unique index is available, use that
			IF EMPTY(aPkey) THEN
				SELECT RmtExpr FROM (lcEnumIndexesTbl) WHERE RTRIM(IndexName)==RTRIM(aTableNames[i,1]) ;
					AND RmtType="UNIQUE" ;
					INTO ARRAY aPkey
			ENDIF

			IF !EMPTY(aPkey) THEN
				*Make the whole thing updatable
				IF !DBSETPROP(RTRIM(aTableNames[i,1]),"view","SendUpdates",.T.) THEN
					lcViewErr=UPDATE_PROP_FAILED_LOC
				ENDIF

				*Set the keyfields
				DIMENSION aKeyFields[1]
				aKeyFields=.F.
				this.KeyArray(aPkey,@aKeyFields)
				FOR ii=1 TO ALEN(aKeyFields,1)
					IF !DBSETPROP(RTRIM(aTableNames[i,1])+"."+RTRIM(aKeyFields[ii]),"field","keyfield",.T.) THEN
						lcErrString=STRTRAN(KEYFIELD_PROP_FAILED_LOC,'|1',RTRIM(aKeyFields[ii]))
						lcViewErr=lcViewErr+lcCRLF+lcErrString
					ENDIF
				NEXT ii
				
				*Make all the fields updatable
				DIMENSION aFldNames[1]
				aFldNames=.F.
				SELECT RmtFldName FROM (lcEnumFieldsTbl) WHERE RTRIM(TblName)==RTRIM(aTableNames[i,1]) ;
					INTO ARRAY aFldNames					
				IF !EMPTY(aFldNames) THEN
					FOR ii=1 TO ALEN(aFldNames,1)
						IF !DBSETPROP(RTRIM(aTableNames[i,1])+"."+RTRIM(aFldNames[ii]),"field","updatable",.T.) THEN
							lcErrString=STRTRAN(UPDATABLE_PROP_FAILED_LOC,'|1',RTRIM(aKeyFields[ii]))
							lcViewErr=lcViewErr+lcCRLF+lcErrString
						ENDIF
					NEXT ii
				ENDIF
				
			ELSE
			
				lcViewErr=NO_UNIQUEKEY_LOC
			
			ENDIF
			
			*store these table and view names somewhere
			LOCATE FOR LOWER(RTRIM(&lcEnumTablesTbl..TblName))==LOWER(RTRIM(aTableNames[i,1]))
			REPLACE NewTblName WITH lcNewTblName, RmtView WITH RTRIM(aTableNames[i,1]), ;
			ViewErr WITH lcViewErr
			
			lcViewErr=""
			
		NEXT i
		
		SELECT (lnOldArea)
		
		this.ThermRef.complete
		
	ENDPROC 

	*--SAS 03/02/99. Original order in index expression is switching around by original 
	*								 ExtractFieldNames() function. This one is keeping 
	FUNCTION ExtractFieldNames
		LPARAMETERS lcExpression, lcTableName
		LOCAL lcReturnExpression
		
		lcReturnExpression = UPPER(STRTRAN(lcExpression, " "))
		lcReturnExpression = STRTRAN(lcReturnExpression, "+", ",")
		lcReturnExpression = STRTRAN(lcReturnExpression, "STR(")
		lcReturnExpression = STRTRAN(lcReturnExpression, ")")
		
		RETURN lcReturnExpression
		
	ENDFUNC 
	
ENDDEFINE
